
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "semanin@gmail.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Silver
#property indicator_color2 Red
#property indicator_color3 Green

extern int NoiseLevel = 30;
extern int SwitchPercent = 30;
extern int Mode = 0;
extern int OncePerCandle = 1;
extern int MaxBars = 300;
extern int ArrowOffset = 15;
double var_g___ibuf_100[];
double var_g___ibuf_104[];
double var_g___ibuf_108[];
int var_g_i__unused_112 = 3;
bool var_g_i__unused_116 = FALSE;
double var_g_d__152;
double var_g_d__unused_160;
double var_g_d__168 = 0.0;
double var_g_d__176 = 0.0;
double var_g_d__184 = 0.0;
double var_g_d__192 = 0.0;
double var_g_d__200 = 0.0;
int var_g_i__208 = 0;
int var_g_i__212 = 0;
int var_g_i__216 = 0;
int var_g_i__unused_220 = 0;
int var_g_i__unused_224 = -1;
int var_g___bars_228 = 0;
int var_g___time_232 = 0;
int var_g_i__unused_236 = 0;

int new_candle() {
   if (var_g___time_232 != Time[0] || var_g___bars_228 != Bars) {
      var_g___time_232 = Time[0];
      var_g___bars_228 = Bars;
      return (1);
   }
   return (0);
}

int init() {
   IndicatorBuffers(3);
   SetIndexStyle(0, DRAW_SECTION, STYLE_SOLID, 2);
   SetIndexBuffer(0, var_g___ibuf_100);
   SetIndexBuffer(1, var_g___ibuf_104);
   SetIndexBuffer(2, var_g___ibuf_108);
   SetIndexStyle(1, DRAW_ARROW, EMPTY, 3, Red);
   SetIndexArrow(1, SYMBOL_ARROWDOWN);
   SetIndexStyle(2, DRAW_ARROW, EMPTY, 3, Green);
   SetIndexArrow(2, SYMBOL_ARROWUP);
   SetIndexEmptyValue(0, 0.0);
   IndicatorShortName("ZigZag_Larsen");
   var_g_i__unused_236 = 0;
   if (Mode == 0) {
      var_g_d__168 = Close[0] - NoiseLevel / 2 * Point;
      var_g_d__176 = Close[0] + NoiseLevel / 2 * Point;
   } else {
      var_g_d__168 = Open[0] - NoiseLevel / 2 * Point;
      var_g_d__176 = Open[0] + NoiseLevel / 2 * Point;
   }
   var_g_d__200 = Open[0];
   var_g_d__176 = var_g_d__168;
   var_g_d__184 = var_g_d__168;
   var_g_d__192 = var_g_d__168;
   var_g_d__152 = var_g_d__168;
   var_g_d__unused_160 = var_g_d__152;
   return (0);
}

int start() {
   int var_l___ind_counted_4 = IndicatorCounted();
   if (!new_candle())
      if (OncePerCandle == 1) return (0);
   int var_l_i__32 = Bars;
   if (var_l_i__32 > MaxBars) var_l_i__32 = MaxBars;
   int var_l_i__8 = var_l_i__32;
   var_g_i__unused_224 = var_l_i__8;
   var_g_i__unused_220 = 0;
   var_g___ibuf_100[1] = var_g_d__200;
   int var_l_i__12 = var_l_i__8 - 1;
   if (Mode == 0) var_g___ibuf_100[var_l_i__12] = Close[var_l_i__12];
   else var_g___ibuf_100[var_l_i__12] = Open[var_l_i__12];
   while (var_l_i__12 >= 0) {
      GetMoving(var_l_i__12);
      if (var_g_i__216 == TRUE) {
         if (var_g_i__208 == 1) {
            var_g___ibuf_100[var_l_i__12] = var_g_d__184;
            var_g___ibuf_108[var_l_i__12] = var_g_d__184 - ArrowOffset * Point;
            var_g___ibuf_104[var_l_i__12] = 0.0;
            if (var_l_i__12 == 0) var_g_d__200 = var_g_d__184;
         }
         if (var_g_i__208 == -1) {
            var_g___ibuf_100[var_l_i__12] = var_g_d__192;
            var_g___ibuf_104[var_l_i__12] = var_g_d__192 + ArrowOffset * Point;
            var_g___ibuf_108[var_l_i__12] = 0.0;
            if (var_l_i__12 == 0) var_g_d__200 = var_g_d__192;
         }
         var_g_i__216 = FALSE;
      } else {
         if (var_l_i__12 == 0) {
            if (var_g_i__208 == 1) var_g___ibuf_100[0] = var_g_d__176;
            if (var_g_i__208 == -1) var_g___ibuf_100[0] = var_g_d__168;
         } else {
            var_g___ibuf_100[var_l_i__12] = 0.0;
            var_g___ibuf_104[var_l_i__12] = 0.0;
            var_g___ibuf_108[var_l_i__12] = 0.0;
            if (var_l_i__12 == 0) var_g_d__200 = 0.0;
         }
      }
      var_l_i__12--;
   }
   return (0);
}

int GetMoving(int var_a_i__0) {
   int var_l_i__24 = (var_g_d__176 - var_g_d__168) * SwitchPercent / 100.0;
   if (var_l_i__24 < NoiseLevel) var_l_i__24 = NoiseLevel;
   if (Mode == 1) var_g_d__152 = Open[var_a_i__0];
   else {
      if (var_g_i__208 != -1) var_g_d__152 = High[var_a_i__0];
      else var_g_d__152 = Low[var_a_i__0];
   }
   if (var_g_i__208 != -1 && var_g_d__152 > var_g_d__176) var_g_d__176 = var_g_d__152;
   if (var_g_i__208 != 1 && var_g_d__152 < var_g_d__168) var_g_d__168 = var_g_d__152;
   if (var_g_d__176 - var_g_d__168 >= NoiseLevel * Point) {
      if (var_g_i__208 != 1 && var_g_d__152 - var_g_d__168 >= var_l_i__24 * Point) {
         var_g_i__208 = 1;
         var_g_d__184 = var_g_d__168;
         var_g_d__176 = var_g_d__152;
         var_g_d__unused_160 = var_g_d__152;
      }
      if (var_g_i__208 != -1 && var_g_d__176 - var_g_d__152 >= var_l_i__24 * Point) {
         var_g_i__208 = -1;
         var_g_d__192 = var_g_d__176;
         var_g_d__168 = var_g_d__152;
         var_g_d__unused_160 = var_g_d__152;
      }
   }
   if (var_g_i__212 != var_g_i__208) {
      var_g_i__212 = var_g_i__208;
      var_g_i__216 = TRUE;
   }
   return (var_g_i__208);
}